#include "fivewin.ch"

#define BIF_RETURNONLYFSDIRS   0x0001  // For finding a folder to start document searching
#define BIF_DONTGOBELOWDOMAIN  0x0002  // For starting the Find Computer
#define BIF_STATUSTEXT         0x0004   // Top of the dialog has 2 lines of text for BROWSEINFO.lpszTitle and one line if
                                        // this flag is set.  Passing the message BFFM_SETSTATUSTEXTA to the hwnd can set the
                                        // rest of the text.  This is not used with BIF_USENEWUI and BROWSEINFO.lpszTitle gets
                                        // all three lines of text.
#define BIF_RETURNFSANCESTORS  0x0008
#define BIF_EDITBOX            0x0010   // Add an editbox to the dialog
#define BIF_VALIDATE           0x0020   // insist on valid result (or CANCEL)

#define BIF_NEWDIALOGSTYLE     0x0040   // Use the new dialog layout with the ability to resize
                                        // Caller needs to call OleInitialize() before using this API

#define BIF_USENEWUI           (BIF_NEWDIALOGSTYLE | BIF_EDITBOX)

#define BIF_BROWSEINCLUDEURLS  0x0080   // Allow URLs to be displayed or entered. (Requires BIF_USENEWUI)
#define BIF_UAHINT             0x0100   // Add a UA hint to the dialog, in place of the edit box. May not be combined with BIF_EDITBOX
#define BIF_NONEWFOLDERBUTTON  0x0200   // Do not add the "New Folder" button to the dialog.  Only applicable with BIF_NEWDIALOGSTYLE.
#define BIF_NOTRANSLATETARGETS 0x0400   // don't traverse target as shortcut

#define BIF_BROWSEFORCOMPUTER  0x1000  // Browsing for Computers.
#define BIF_BROWSEFORPRINTER   0x2000  // Browsing for Printers
#define BIF_BROWSEINCLUDEFILES 0x4000  // Browsing for Everything
#define BIF_SHAREABLE          0x8000  // sharable resources displayed (remote shares, requires BIF_USENEWUI)



function main()

? BrowseFolder( 0, "Probando", BIF_BROWSEFORCOMPUTER )

return nil



#pragma BEGINDUMP
#include <hbapi.h>
#include <windows.h>
#include <shlobj.h>
#include <shtypes.h>

HB_FUNC( BROWSEFOLDER )
{
   
   HWND hWnd = ( HWND ) hb_parnl( 1 );
   ITEMIDLIST * ppidl;
   BROWSEINFO  lpbi;
   char pszDisplayName[MAX_PATH];
   char pszReturn[MAX_PATH];
   
   memset( &lpbi, 0x00, sizeof( BROWSEINFO ) );
   
   if( SHGetSpecialFolderLocation( hWnd, CSIDL_NETWORK, &ppidl ) == S_OK )
   {
      lpbi.hwndOwner   = hWnd;  
      lpbi.pidlRoot = ppidl;  
      lpbi.pszDisplayName = pszDisplayName; 
      lpbi.lpszTitle = hb_parc( 2 );  
      lpbi.ulFlags = hb_parnl( 3 ) ;
      if( SHBrowseForFolder(&lpbi) != 0 )
         strcpy( pszReturn, lpbi.pszDisplayName );
      else
         strcpy( pszReturn, "\0" );
   }
   
   hb_retc( pszReturn );

}


#pragma ENDDUMP